# @sme-uploader/dashboard

<img src="https://sme-uploader.web.app/images/logos/favicon.png" width="120" alt="SME Uploader logo" align="right">
<a href="https://www.npmjs.com/package/@sme-uploader/dashboard"><img src="https://img.shields.io/npm/v/@sme-uploader/dashboard.svg?style=flat-square"></a>
<a href="https://travis-ci.org/SME-AOMA/npm-uploader"><img src="https://img.shields.io/travis/SME-AOMA/npm-uploader/master.svg?style=flat-square" alt="Build Status"></a>

Dashboard is a universal UI plugin for SME Uploader:

 * Drag and Drop, paste, select from local disk / my device
 * UI for Webcam and remote sources: Google Drive, Dropbox, Instagram (all optional, added via plugins)
 * File previews and info
 * Metadata editor
 * Progress: total and for individual files
 * Ability to pause/resume or cancel (depending on uploader plugin) individual or all files

**[Read the Docs](https://sme-uploader.web.app/docs)** | **[Try SME Uploader](https://sme-uploader.web.app/examples/dashboard/)**

## Example

```js
const SmeUploader = require('@sme-uploader/core');
const Dashboard = require('@sme-uploader/dashboard');

const uploader = new SmeUploader()
uploader.use(Dashboard, {
  target: 'body',
  inline: true
});
```

## Installation

```bash
$ npm install @sme-uploader/dashboard
```

We recommend installing from npm and then using a module bundler such as [Parcel](https://parceljs.org/), [Webpack](https://webpack.js.org/) or [Browserify](http://browserify.org/).

Alternatively, you can also use this plugin in a pre-built bundle from CDN. In that case `SmeUploader` will attach itself to the global `window.SmeUploader` object. See the [main SME Uploader documentation](https://sme-uploader.web.app/docs/#Installation) for instructions.

## Documentation

Documentation for this plugin can be found on the [SME Uploader website](https://sme-uploader.web.app/docs/sme-uploader).

## License

[The MIT License](./LICENSE).
