var _require = require('preact'),
    h = _require.h;

var classNames = require('classnames');

function EditorPanel(props) {
  var file = this.props.files[this.props.fileCardFor];
  return h("div", {
    class: classNames('uploader-DashboardContent-panel', props.className),
    role: "tabpanel",
    "data-uploader-panelType": "FileEditor",
    id: "uploader-DashboardContent-panel--editor"
  }, h("div", {
    class: "uploader-DashboardContent-bar"
  }, h("div", {
    class: "uploader-DashboardContent-title",
    role: "heading",
    "aria-level": "1"
  }, props.i18nArray('editing', {
    file: h("span", {
      class: "uploader-DashboardContent-titleFile"
    }, file.meta ? file.meta.name : file.name)
  })), h("button", {
    class: "uploader-DashboardContent-back",
    type: "button",
    onclick: props.hideAllPanels
  }, props.i18n('done'))), h("div", {
    class: "uploader-DashboardContent-panelBody"
  }, props.editors.map(function (target) {
    return props.getPlugin(target.id).render(props.state);
  })));
}

module.exports = EditorPanel;