const { h } = require('preact');
const classNames = require('classnames');
const AddFiles = require('./addFiles');

const AddFilesPanel = (props) => {
  return (
    <div
      class={classNames('uploader-Dashboard-AddFilesPanel', props.className)}
      data-uploader-panelType="AddFiles"
      aria-hidden={props.showAddFilesPanel}
    >
      <div class="uploader-DashboardContent-bar">
        <div class="uploader-DashboardContent-title" role="heading" aria-level="1">
          {props.i18n('addingMoreFiles')}
        </div>
        <button
          class="uploader-DashboardContent-back"
          type="button"
          onclick={(ev) => props.toggleAddFilesPanel(false)}
        >{props.i18n('back')}
        </button>
      </div>
      <AddFiles {...props} />
    </div>
  );
};

module.exports = AddFilesPanel;
