const { h } = require('preact');
const classNames = require('classnames');

function EditorPanel(props) {
  const file = this.props.files[this.props.fileCardFor];

  return (
    <div
      class={classNames('uploader-DashboardContent-panel', props.className)}
      role="tabpanel"
      data-uploader-panelType="FileEditor"
      id="uploader-DashboardContent-panel--editor"
    >
      <div class="uploader-DashboardContent-bar">
        <div class="uploader-DashboardContent-title" role="heading" aria-level="1">
          {props.i18nArray('editing', {
            file: <span class="uploader-DashboardContent-titleFile">{file.meta ? file.meta.name : file.name}</span>
          })}
        </div>
        <button
          class="uploader-DashboardContent-back"
          type="button"
          onclick={props.hideAllPanels}
        >
          {props.i18n('done')}
        </button>
      </div>
      <div class="uploader-DashboardContent-panelBody">
        {props.editors.map((target) => {
          return props.getPlugin(target.id)
            .render(props.state);
        })}
      </div>
    </div>
  );
}

module.exports = EditorPanel;
