const getFileTypeIcon = require('../utils/getFileTypeIcon');
const { h } = require('preact');

module.exports = function FilePreview(props) {
  const file = props.file;

  if (file.preview) {
    return (
      <img
        class="uploader-Dashboard-Item-previewImg"
        alt={file.name}
        src={file.preview}
      />
    );
  }

  const { color, icon } = getFileTypeIcon(file.type);

  return (
    <div class="uploader-Dashboard-Item-previewIconWrap">
      <span class="uploader-Dashboard-Item-previewIcon" style={{ color: color }}>{icon}</span>
      <svg aria-hidden="true" focusable="false" class="uploader-Dashboard-Item-previewIconBg" width="58" height="76"
           viewBox="0 0 58 76">
        <rect fill="#FFF" width="58" height="76" rx="3" fill-rule="evenodd"/>
      </svg>
    </div>
  );
};
