const { h } = require('preact');
const classNames = require('classnames');
const ignoreEvent = require('../utils/ignoreEvent.js');

const PickerPanelContent = (props) => {
  return (
    <div
      class={classNames('uploader-DashboardContent-panel', props.className)}
      role="tabpanel"
      data-uploader-panelType="PickerPanel"
      id={`uploader-DashboardContent-panel--${props.activePickerPanel.id}`}
      onDragOver={ignoreEvent}
      onDragLeave={ignoreEvent}
      onDrop={ignoreEvent}
      onPaste={ignoreEvent}
    >
      <div class="uploader-DashboardContent-bar">
        <div class="uploader-DashboardContent-title" role="heading" aria-level="1">
          {props.i18n('importFrom', { name: props.activePickerPanel.name })}
        </div>
        <button
          class="uploader-DashboardContent-back"
          type="button"
          onclick={props.hideAllPanels}
        >{props.i18n('done')}
        </button>
      </div>
      <div class="uploader-DashboardContent-panelBody">
        {props.getPlugin(props.activePickerPanel.id)
          .render(props.state)}
      </div>
    </div>
  );
};

module.exports = PickerPanelContent;
