import {expectType, expectError} from 'tsd'
import SmeUploader = require('@sme-uploader/core')
import Dashboard = require('../')

{
  const uploader = SmeUploader<SmeUploader.StrictTypes>()
  uploader.use(Dashboard, {
    target: 'body'
  })

  const plugin = uploader.getPlugin('Dashboard') as Dashboard
  plugin.openModal()
  expectType<boolean>(plugin.isModalOpen())
  plugin.closeModal()
}

{
  const uploader = SmeUploader<SmeUploader.StrictTypes>()
  uploader.use(Dashboard, {
    width: '100%',
    height: 700,
    metaFields: [
      {id: 'caption', name: 'Caption'},
      {
        id: 'license',
        name: 'License',
        placeholder: 'Creative Commons, Apache 2.0, ...'
      },
      {
        id: 'public',
        name: 'Public',
        render({value, onChange}, h) {
          expectType<string>(value)
          expectType<(val: string) => void>(onChange)
          // `h` should be the Preact `h`
          // expectError(h([], 'error'))
          /* Currently `h` typings are limited because of a JSX type conflict between React and Preact.
          return h('input', {
            type: 'checkbox',
            checked: value === 'yes',
            onChange: (event) => {
              expectType<Event>(event)
              onChange((event.target as HTMLInputElement).checked ? 'yes' : 'no')
            }
          })
          */
        }
      }
    ]
  })
}

/* (?)
{
  const uploader = SmeUploader<SmeUploader.StrictTypes>()
  uploader.use(Dashboard, {
    locale: {
      strings: {
        // Dashboard string
        addMoreFiles: 'yaddayadda',
        // StatusBar string
        uploading: '^^^^'
      }
    }
  })
  expectError(uploader.use(Dashboard, {
    locale: {
      strings: {
        somethingThatDoesNotExist: 'wrong'
      }
    }
  }))
  const wrongType = 1234
  expectError(uploader.use(Dashboard, {
    locale: {
      strings: {
        addMoreFiles: wrongType
      }
    }
  }))
}
*/
{
  const uploader = SmeUploader<SmeUploader.StrictTypes>()
  // expectError(uploader.use(Dashboard, {height: {}}))
}
